use std::collections::HashMap;

use crate::utils::input_reader;
use crate::year_2023::day_08_haunted_wasteland::common::{parse_line, Node};

pub fn part_one() -> String {
    if let Ok(lines) = input_reader::read_lines("./input/2023/day_08/input.txt") {
        let mut node_map: HashMap<String, Node> = HashMap::new();
        let mut instructions: Vec<char> = Vec::new();
        let mut s: String;

        for (i, line) in lines.enumerate() {
            s = line.unwrap();

            if i == 0 {
                instructions = s.chars().collect();
                continue;
            }

            if s.is_empty() {
                continue;
            }

            let node = parse_line(&s);
            node_map.insert(node.value.clone(), node);
        }

        let mut curr = &node_map["AAA"];
        let mut count = 0;

        while curr.value != "ZZZ" {
            let i = count % instructions.len();

            if instructions[i] == 'L' {
                curr = &node_map[&curr.left];
            } else if instructions[i] == 'R' {
                curr = &node_map[&curr.right];
            }

            count += 1;
        }

        return count.to_string();
    } else {
        panic!("Failed to read lines from input file");
    }
}
