use super::common::{parse_line, get_differences, all_zeros};

pub fn part_one(input_lines: Vec<String>) -> String {
    let mut result: i32 = 0;

    for line in input_lines {
        let nums = parse_line(&line);

        let mut last: Vec<i32> = Vec::new();
        last.push(nums.last().unwrap().clone());

        let mut diffs = get_differences(nums.clone());
        last.push(diffs.last().unwrap().clone());

        while !all_zeros(diffs.clone()) {
            diffs = get_differences(diffs.clone());
            last.push(diffs.last().unwrap().clone());
        }

        result += last.iter().sum::<i32>();
    }

    result.to_string()
}