pub fn part_one(input_lines: Vec<String>) -> String {

    let mut full_line: String = String::new();
    for line in input_lines {
        full_line.push_str(&line);
    }

    let init_sequences = full_line.split(',').collect::<Vec<&str>>();
    let mut result = 0;

    for seq in init_sequences {
        result += hash_sequence(seq);
    }

    result.to_string()
}

fn hash_sequence(sequence: &str) -> usize {
    
    let mut hash = 0;
    for c in sequence.chars() {
        hash += c as usize;
        hash *= 17;
        hash %= 256;
    }

    hash
}